<?php

require_once( 'includes/OpenTTDLibException.php' );
require_once( 'includes/OpenTTDLibPacket.php' );
require_once( 'includes/OpenTTDLibCache.php' );
require_once( 'includes/OpenTTDLib.php' );

$openttd = new OpenTTDLib();
$openttd->setOption( OpenTTDLib::OPTION_CACHE_NEWGRF,	true          );
$openttd->setOption( OpenTTDLib::OPTION_CACHE_FILE,	    'cache.xml'   );
$openttd->setOption( OpenTTDLib::OPTION_CACHE_UPDATE,	true          );

$server['host']     = 'ottd.instation.ru'; // Ip адресс сервера
$server['port']     = '3979'; // Порт сервера

try
{
    $openttd->queryServer( $server['host'], $server['port'] ); 
}
catch ( OpenTTDLibException $e )
{
        die( 'Connection error' );    
}
    
$info	= $openttd->getInfo();
$detail	= $openttd->getDetail();
$newgrf	= $openttd->getNewGrf( true );	        

$companies  = '';
$total_arr  = array();
$total      = '';

foreach( $detail->player as $player )
{         
    $companies.=    '<tr>                            
    	<td class="value_id">'.($player->current + 1).'</td>
    	<td class="value_company_name">'.$player->company_name.'&nbsp;&nbsp;'.($player->password ? '<img src="images/lock.png" title="Protected" alt="Protected">' : '').'</td>
    	<td class="value">'.$player->inaugurated.'</td>
    	<td class="value">'.number_format( bcmul( $player->company_value, 2 ), 0, ".", "," ).'</td>
    	<td class="value">'.number_format( bcmul( $player->money, 2 ), 0, ".", "," ).'$</td>
    	<td class="value">'.number_format( bcmul( $player->income, 2 ), 0, ".", "," ).'$</td>
    	<td class="value">'.$player->performance.'</td>
    	<td class="'.( $player->vehicles[0] == 0 ? 'value_empty':'value').'">'.$player->vehicles[0].'</td>
    	<td class="'.($player->vehicles[1]==0?'value_empty':'value').'">'.$player->vehicles[1].'</td>
    	<td class="'.($player->vehicles[2]==0?'value_empty':'value').'">'.$player->vehicles[2].'</td>
    	<td class="'.($player->vehicles[3]==0?'value_empty':'value').'">'.$player->vehicles[3].'</td>
    	<td class="'.($player->vehicles[4]==0?'value_empty':'value').'">'.$player->vehicles[4].'</td>
    	<td class="'.($player->stations[0]==0?'value_empty':'value').'">'.$player->stations[0].'</td>
    	<td class="'.($player->stations[1]==0?'value_empty':'value').'">'.$player->stations[1].'</td>
    	<td class="'.($player->stations[2]==0?'value_empty':'value').'">'.$player->stations[2].'</td>
    	<td class="'.($player->stations[3]==0?'value_empty':'value').'">'.$player->stations[3].'</td>
    	<td class="'.($player->stations[4]==0?'value_empty':'value').'">'.$player->stations[4].'</td>
    	</tr>';
        
        for( $i = 0; $i <= 4; $i++ )
        {
            $total_arr['vehicles'][$i] += $player->vehicles[$i];
            $total_arr['stations'][$i] += $player->stations[$i];
        }
}

if( !$companies )
{
    $companies.= '<tr><td colspan="17">No companies</td></tr>';   
} 
else 
{
    $total.= '<tr><td colspan="7" class="value_total">Total:</td>';
    
    foreach( $total_arr['vehicles'] as $values )
        $total.= '<td class="'.($values == 0 ? 'value_empty':'value' ).'">'.$values.'</td>';    
    
    foreach( $total_arr['stations'] as $values )
        $total.= '<td class="'.($values == 0 ? 'value_empty':'value' ).'">'.$values.'</td>';        
    
    $total.= '</tr>';
}

$x_grf = '';
foreach( $newgrf as $key => $grf )
{
    
    $x_grf.= '<tr>
                <td class="grf_value">'.$grf->name.'</td>
                <td class="grf_value"><a href="http://grfcrawler.tt-forums.net/index.php?do=search&q='.$grf->id.'">'.$grf->id.'</a></td>
                <td class="grf_value_center">'.$grf->md5sum.'</td>
            </tr>';
}

?>

<html> 
<head>
    <title><?= $info->name ?></title>
    <meta name="Description" content="Openttd server, Сервер игры Openttd">
    <meta http-equiv="content-type" content="text/html; charset=UTF-8"> 
    <style type="text/css">
    html,body,div,h1,h2,h3,h4,h5,h6,p,img,dl,dt,dd,ol,ul,li,caption,tbody,tfoot,thead,tr,th,td,form,fieldset,embed,object,applet{margin:0;padding:0;border:0;font-family:Tahoma;font-size:11px;}
    body{color:#000;background:#fff; padding: 0; margin: 0;}
    a {color:#105CB6}
    a:hover {color: #FF6600}
    a:active{color:#f00}
    a:visited{color:#105CB6}
    p {margin: 3px 0}
    .container {height: 100%; width: 100%}
    .left_side {height: 100%; border-right: 4px solid #EBEFF9; width: 190px;}
    .logo {position: absolute; top: 1px; right: 2px; }
    .srv_info {margin: 5px 0 4px 0; padding: 10px 0 0 0;}
    .srv_name {height: 30px; background: #EBEFF9; padding: 5px;}
    .srv_name a {text-decoration: none; font-weight: bold; font-size: 1.3em; color: black}
    .value, .value_empty, .value_total, .value_company_name, .value_id {text-align:center;border-bottom: 1px dotted #EBEFF9; padding: 7px}
    .value_empty {color: #C0C0C0}
    .value_total {text-align: right; font-weight: bold; font-size: 1.1em;}
    .value_company_name, .value_id {text-align: left}
    .value_id {padding-left: 10px}
    .grf_value, .grf_value_center {border-bottom: 1px dotted #EBEFF9; padding: 4px;}
    .grf_value_center {text-align: center}
    
    </style>
</head>
<body>
<div class="logo"><a href="http://www.openttd.org/"><img src="images/OpenttdLogo.png" border="0" /></a></div>

<table class="container" cellpadding="0" cellspacing="0"><tr>
    <td colspan="2" class="srv_name"><a href="/"><?=$info->name?></a></td>
    </tr><tr>
    <td class="left_side" valign="top">
        <div style="padding: 0 10px 0 10px">
            <div class="srv_info">
                <?=$info->dedicated ? '<img src="images/dedicated.png" alt="dedicated" title="dedicated" />' : '<img src="images/nondedicated.png" alt="nondedicated" title="nondedicated" />';?>
                <img src="images/<?=$info->server_lang?>_lang.gif" alt="lang" title="server language" />
                <?=$info->use_password ? '<img src="images/lock.png" alt="lock" title="protected" />' : '';?>
            </div>    
            <div align="center" style="margin-top: 10px;"><img src="images/<?=$info->map_set?>_landscape.png" alt="map set image" title="map set" /></div>
            <div style="margin: 10px 0 0 0; padding: 10px 0 0 0">Version:&nbsp; <?=$info->revision?></div>        
    
            <table style="margin: 10px 0 5px 0; padding: 5px 10px 10px 0px; border-top: 1px solid #EBEFF9; width: 100%;" cellpadding="0" cellspacing="0"><tr>
                <td style="padding: 3px 10px 3px 0px;">Map size:</td>
                <td><?=$info->map_width.' x '.$info->map_height?></td>
            </tr><tr>        
                <td style="padding: 3px 10px 3px 0px;">Game Start:</td>
                <td><?=$info->start_date?></td>
            </tr><tr>
                <td style="padding: 3px 10px 3px 0px;">Current date:</td>
                <td><?=$info->game_date?></td>
            </tr><tr>
                <td style="padding: 3px 10px 3px 0px;">Companies:</td>
                <td><b><?=$info->companies_on.'/'.$info->companies_max?></b></td>
            </tr><tr>                
                <td style="padding: 3px 10px 3px 0px;">Clients:</td>
                <td><b><?=$info->clients_on.'/'.$info->clients_max?></b></td>
            </tr><tr>    
                <td style="padding: 3px 10px 10px 0px;">Spectators:</td>
                <td style="padding: 3px 10px 10px 0px;"><b><?=$info->spectators_on.'/'.$info->spectators_max?></b></td>
            </tr></table>
        </div>                 
    </td>
    <td valign="top" style="padding: 10px;" align="center">    
        <div style="text-align: left; margin-top: 10px; font-size: 1.5em">Companies:</div>
    	<table cellspacing="0" cellpadding="0" width="100%" style="margin: 5px 0 0 0" align="center">
            <tr style="padding-bottom:5px;" bgcolor="#EBEFF9">            
                <td rowspan="2" style="vertical-align:center; padding: 9px 0 9px 10px"><strong>#</strong></td>
                <td rowspan="2" style="vertical-align:center;" ><strong>Company</strong></td>
                <td rowspan="2" style="text-align:center;vertical-align:center;" ><strong>Start</strong></td>
                <td rowspan="2" style="text-align:center;vertical-align:center;" ><strong>Value</strong></td>
                <td rowspan="2" style="text-align:center;vertical-align:center;" ><strong>Money</strong></td>
                <td rowspan="2" style="text-align:center;vertical-align:center;" ><strong>Income</strong></td>
                <td rowspan="2" style="text-align:center;vertical-align:center;" ><strong>Performance</strong></td>
                <td colspan="5" style="text-align:center;vertical-align:middle; padding: 4px 0 0 0 "><strong>Vehicles</strong></td>
                <td colspan="5" style="text-align:center;vertical-align:middle; padding: 4px 0 0 0 "><strong>Stations</strong></td>
                <td rowspan="2"></td>
            </tr>
    		<tr bgcolor="#EBEFF9">
    			<td style="text-align:center;vertical-align:middle;" ><img src="images/0_vst_dark.gif" alt="Train" title="Train" /></td>
                <td style="text-align:center;vertical-align:middle;" ><img src="images/1_vst_dark.gif" alt="Truck" title="Truck" /></td>
    			<td style="text-align:center;vertical-align:middle;" ><img src="images/2_vst_dark.gif" alt="Bus" title="Bus" /></td>
    			<td style="text-align:center;vertical-align:middle;" ><img src="images/3_vst_dark.gif" alt="Air" title="Air" /></td>
    			<td style="text-align:center;vertical-align:middle;" ><img src="images/4_vst_dark.gif" alt="Ship" title="Ship" /></td>
    			<td style="text-align:center;vertical-align:middle;" ><img src="images/0_vst_dark.gif" alt="Train" title="Train" /></td>
    			<td style="text-align:center;vertical-align:middle;" ><img src="images/1_vst_dark.gif" alt="Truck" title="Truck" /></td>
    			<td style="text-align:center;vertical-align:middle;" ><img src="images/2_vst_dark.gif" alt="Bus" title="Bus" /></td>
    			<td style="text-align:center;vertical-align:middle;" ><img src="images/3_vst_dark.gif" alt="Air" title="Air" /></td>
    			<td style="text-align:center;vertical-align:middle;" ><img src="images/4_vst_dark.gif" alt="Ship" title="Ship" /></td>
            </tr>
            <!-- Companies List --> 
            <?= $companies ?>
            <?= $total ?>   
            </table>
            <!-- GRF List -->
            <?php if( $x_grf ) {?>
            <div style="text-align: left; margin-top: 15px; font-size: 1.5em">Used GRF:</div>
            <table cellspacing="0" cellpadding="0" width="100%" style="margin: 5px 0 0 0" align="center"><tr style="padding-bottom:5px;" bgcolor="#EBEFF9">
                <td style="padding: 9px 0 9px 10px"><strong>NewGRF name</strong></td>
                <td><strong>NewGRF ID</strong></td>
                <td style="text-align: center;"><strong>NewGRF MD5 Checksum</strong></td>
            </tr>
            <?= $x_grf ?>
            </table>
            <?php } ?>
       </td>
</tr></table>
</body>
</html>                 